#ifndef CAN_H
  #define CAN_H

  #include <inttypes.h>

  #define setbit(ADR,BIT)   (ADR |= (1<<BIT))
  #define clearbit(ADR,BIT) (ADR &=~(1<<BIT))
  #define getbit(ADR, BIT)  (ADR &  (1<<BIT))

  /* CAN Objekte */
  #define NO_MOBS 15   // Anzahl der Message Objects festlegen
  #define NOMOB   0xff // Definition für ungültigen Objektindex

  // "hauptfunktionen"
  int can_init(uint8_t baudrate, uint8_t intmode, uint8_t eid);
  int can_deinit(void);
  int can_enable_mob(uint8_t mob, uint8_t mode, uint32_t id, uint32_t idm);
  int can_disable_mob(uint8_t mob);
  int can_send_data(uint8_t mob, uint8_t length, int8_t * data);
  int can_send_remote(uint8_t mob);
  void can_set_autoreply(uint8_t mob, uint8_t length, int8_t *buf);

  // sonstige hilfsfunktionen
  int can_set_baudrate(uint8_t baudrate);
  int can_set_interrupt(uint8_t mode);
  void can_get_mob(uint8_t mob);
  uint32_t can_get_id(void);
  void can_set_id_mask(uint32_t idm);
  void can_set_id(uint32_t id);
  int can_set_mode(uint8_t mode);
  uint8_t can_get_mode(void);
  void can_set_data(uint8_t length, int8_t * data);
  void can_get_data(int8_t *msg);
  void can_set_mob_interrupt(uint8_t object);
  void can_clear_mob_interrupt(uint8_t mob);
  uint8_t can_get_mob_interrupt(void);

#endif /* CAN_H */
