#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdbool.h>

#define F_CPU 16000000ULL
#include <util/delay.h>

#include "can.h"

void sleep(uint32_t i)
{
  while(i--)
    _delay_ms(1);
}

int main(void)
{
  int8_t  data[8];
  uint8_t i;

  data[0] = 'H';
  data[1] = 'i';
  data[2] = ' ';
  data[3] = 't';
  data[4] = 'h';
  data[5] = 'e';
  data[6] = 'r';
  data[7] = 'e';

  // baudrate: 250K, keine Interrupts, extended Id
  can_init(3, 0, 1);

  // mob: 0, modus: senden, id 3, idm 0xffffffff
  can_enable_mob(0, 1, 3, 0xffffffff);

  for(i = 1; i <= 8; i++)
  {
    sleep(1000);
    can_send_data(0, i, data);
  }

  while(1);

  return 0;
}
